/* eslint global-require: 0 */
/* eslint class-methods-use-this: 0 */

describe('Audit', () => {
    describe('store', () => {
        it('should correct extract data', async () => {
            const storeData = {
                metainfo: {
                    userId: 'testUserID',
                    accountId: 'testAccountID',
                    entity: 'testEntity',
                    action: 'testAction',
                    entityId: 'testEntityId',
                    entityName: 'testEntityName',
                    userEmail: 'testUserEmail',
                    userName: 'testUserName'
                },
                request: {
                    url: 'testUrl',
                    body: { test: 1 },
                    query: { query: 1 },
                    params: { params: 1 }
                },
                response: {
                    status: 200
                }
            };


            jest.mock('../audit/audit.dal.js', () => {
                class AuditDal {
                    store(data) {
                        delete data.createdAt;
                        expect(data).toEqual(
                            {
                                'accountId': 'testAccountID',
                                'action': 'testAction',
                                'entity': 'testEntity',
                                'entityId': 'testEntityId',
                                'entityName': 'testEntityName',
                                'req_body': '{"test":1}',
                                'req_params': '{"params":1}',
                                'req_query': '{"query":1}',
                                'req_url': 'testUrl',
                                'rs_status': 200,
                                'userEmail': 'testUserEmail',
                                'userId': 'testUserID',
                                'userName': 'testUserName'
                            }
                        );
                    }
                }
                return new AuditDal();
            });

            const audit = require('../index');
            await audit.store(storeData);
        });
    });
});
